require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ASMACROS_H_)) {
    eval 'sub _MACHINE_ASMACROS_H_ () {1;}' unless defined(&_MACHINE_ASMACROS_H_);
    require 'sys/cdefs.ph';
    eval 'sub CNAME {
        my($csym) = @_;
	    eval q($csym);
    }' unless defined(&CNAME);
    eval 'sub ALIGN_DATA () {. &p2align 2;}' unless defined(&ALIGN_DATA);
    eval 'sub ALIGN_TEXT () {. &p2align 2,0x90;}' unless defined(&ALIGN_TEXT);
    eval 'sub SUPERALIGN_TEXT () {. &p2align 4,0x90;}' unless defined(&SUPERALIGN_TEXT);
    eval 'sub GEN_ENTRY {
        my($name) = @_;
	    eval q( &ALIGN_TEXT; . &globl  &CNAME($name); . &type  &CNAME($name),@ &function;  &CNAME($name):);
    }' unless defined(&GEN_ENTRY);
    eval 'sub ENTRY {
        my($name) = @_;
	    eval q( &GEN_ENTRY($name));
    }' unless defined(&ENTRY);
    eval 'sub ALTENTRY {
        my($name) = @_;
	    eval q( &GEN_ENTRY($name));
    }' unless defined(&ALTENTRY);
    eval 'sub END {
        my($name) = @_;
	    eval q(. &size $name, . - $name);
    }' unless defined(&END);
    if(defined(&LOCORE)) {
	eval 'sub GSEL_KPL () {0x20;}' unless defined(&GSEL_KPL);
	eval 'sub SEL_RPL_MASK () {0x3;}' unless defined(&SEL_RPL_MASK);
	eval 'sub IDTVEC {
	    my($name) = @_;
    	    eval q( &ALIGN_TEXT; . &globl  &__CONCAT( &X,$name); . &type  &__CONCAT( &X,$name),@ &function;  &__CONCAT( &X,$name):);
	}' unless defined(&IDTVEC);
	eval 'sub PCPU {
	    my($member) = @_;
    	    eval q(% &fs: &PC_  $member);
	}' unless defined(&PCPU);
	eval 'sub PCPU_ADDR {
	    my($member, $reg) = @_;
    	    eval q( &movl % &fs: &PC_PRVSPACE, $reg ;  &addl $ &PC_  $member, $reg);
	}' unless defined(&PCPU_ADDR);
    }
    if(defined(&__STDC__)) {
	eval 'sub ELFNOTE () {( &name,  &type,  &desctype,  &descdata...) . &pushsection . ($note->{name}), "a", @ &note ; . &align 4; .\'long 2f\' - 1 &f ; .\'long 4f\' - 3 &f ; .\'long type\' ; 1:. &asciz  &name ; 2:. &align 4; 3: &desctype  &descdata ; 4:. &align 4; . &popsection;}' unless defined(&ELFNOTE);
    } else {
	eval 'sub ELFNOTE {
	    my($name, $type, $desctype, $descdata) = @_;
    	    eval q(. &pushsection . ($note->{name}), \\"a\\", @ &note ; . &align 4; .\'long 2f\' - 1 &f ; .\'long 4f\' - 3 &f ; .\'long type\' ; 1:. &asciz \\"name\\" ; 2:. &align 4; 3:$desctype $descdata ; 4:. &align 4; . &popsection);
	}' unless defined(&ELFNOTE);
    }
}
1;
